#include "header.h"

int N, M, P;
int **n;
int **n1;
int count = 0;
int count1 = 0;
int MS = 0;
result *res;
result *res1;

void Order (Animal *a, int P, int *b)
{
	int max = 0;
	for (int i = 0; i < P; i++)
	{
		max = 0;
		for (int i1 = 0; i1 < P; i1++)
			if (check (a[i1].id, b, i))
			{
				if (max < a[i1].myk)
				{
					max = a[i1].myk;
					b[i] = a[i1].id;
				}
			}
	}
}

bool check (int a, int *b, int o)
{
	if (!o)
		return true;
	for (int i = 0; i < o; i++)
		if (a == b[i])
			return false;
	return true;
}

int Animal::get_safety_at(int xl, int xw)
{
	int safety=0;
	for(int x=0; x < l; x++)
	{
		for(int y=0; y < w; y++)
		{
			if( fig[x][y] < n[xl+x][xw+y])
				safety += n[xl+x][xw+y];
			else 
				return 0;
		}
	}
	return safety;
}

void Animal::decrease_safety_at(int xl, int xw)
{
	for(int x=0; x < l; x++)
	{
		for(int y=0; y < w; y++)
		{
			if( fig[x][y] )
			{
				n[xl+x][xw+y] /= damk;
			}
		}
	}
}


int MaxSafety (Animal p)
{
	int s = 0;
	for (int i = 0; i <= (N - p.l); i++)
		for (int i1 = 0; i1 <= (M - p.w); i1++)
			if (0 != (s = p.get_safety_at (i, i1)))
			{
				if (MS < s)
				{
					MS = s;
					res[count].id = p.id;
					res[count].l = i + 1;
					res[count].w = i1 + 1;
				}
			
			}
	return MS;
}

int MaxSafety1 (Animal p)
{
	int s = 0, ms = 0;
	for (int i = 0; i <= (N - p.l); i++)
		for (int i1 = 0; i1 <= (M - p.w); i1++)
			if (0 != (s = p.get_safety_at (i, i1)))
			{
				if (ms < s)
				{
					ms = s;
					res1[count1].id = p.id;
					res1[count1].l = i + 1;
					res1[count1].w = i1 + 1;
				}
			
			}
	if ( ms )
	{
		p.decrease_safety_at (res1[count1].l - 1, res1[count1].w - 1);
		count1++;
	}
	return ms;
}


void main()
{
	ifstream InFile ("parash.in");
	if (!InFile.is_open())
	{
		cout<<"Unable to open file"<<endl;
		return;
	}
	int MS1 = 0;
	InFile>>N>>M>>P;
	n = new int* [N];
	n1 = new int* [N];
	for (int i = 0; i < N; i++)
	{
		n[i] = new int [M];
		n1[i] = new int [M];
	}
	for (int i = 0; i < N && InFile.good(); i++)
		for (int i1 = 0; i1 < M && InFile.good(); i1++)
		{
			InFile>>n[i][i1];
			n1[i][i1] = n[i][i1];
		}
	Animal *p = new Animal [P];
	res = new result [P];
	res1 = new result [P];
	for (int i = 0; i < P && InFile.good(); i++)
	{
		int temp = 0;
		p[i].flag = false;
		p[i].id = i + 1;
		InFile>>p[i].l>>p[i].w>>p[i].damk>>p[i].safek;
		p[i].fig = new int* [p[i].l];
		for (int il = 0; il < p[i].l; il++)
			p[i].fig[il] = new int [p[i].w];
		for (int il = 0; il < p[i].l; il++)
			for (int iw = 0; iw < p[i].w; iw++)
			{
				char c;
				do{
					InFile.get (c);
				}while(!isdigit(c));
				p[i].fig[il][iw] = (c == '0')?0:p[i].safek;
				if (p[i].fig[il][iw])
					temp++;
			}
		p[i].myk = (100 - temp);//p[i].damk * temp;
	}
	int *order = new int [P] ();
	Order (p, P, order);
	int ms;
	for (int i1 = 0; i1 < P; i1++)
	{
		for (int i = 0; i < P; i++)
		{
			if (p[i].flag == false)
			{
				ms = MaxSafety (p[i]);
			}
		}
		MS1+=ms;
		if (ms)
		{
			p[res[count].id-1].flag = true;
			p[res[count].id-1].decrease_safety_at(res[i1].l-1, res[i1].w-1);
			count++;
		}
		else
			break;
		MS = 0;
	}
	MS = 0;
	for (int i = 0; i < N && InFile.good(); i++)
		for (int i1 = 0; i1 < M && InFile.good(); i1++)
		{
			n[i][i1] = n1[i][i1];
		}
	for (int i = P - 1; 0 < i; i--)
	{
		MS += MaxSafety1 (p[order[i]-1]	);
	}
	for (int i = 0; i < P; i++)
	{
		for (int il = 0; il < p[i].l; il++)
			delete [] p[i].fig[il];
		delete [] p[i].fig;
	}
	for (int i = 0; i < N; i++)
		delete [] n[i];
	delete [] n;
	delete [] n1;
	delete [] p;
	InFile.close();
	ofstream OutFile ("parash.out");
	if (MS1 > MS)
	{
		OutFile<<count<<endl;
		for (int i = 0; i < count; i++)
		{
			OutFile<<res[i].id<<" "<<res[i].l<<" "<<res[i].w<<endl;
		}
	}
	else
	{
		OutFile<<count1<<endl;
		for (int i = 0; i < count1; i++)
		{
			OutFile<<res1[i].id<<" "<<res1[i].l<<" "<<res1[i].w<<endl;
		}
	}
	OutFile.close();
	delete [] res;
	delete [] res1;
}
